﻿var dllCLSID = "{7ED1DCB7-48AD-4D4E-B609-181330032D7F}";
var typeLib = "{6E34C35A-37FC-4926-A4CE-56ECE6F7550A}";
var Classname = "GetGPUInfo.GPUInfo";
var ClassComment = "GPUInfo Class";
var LibComment = "GetGPUInfo 1.0 Type Library";
var gPath = System.Gadget.path.replace(new RegExp("\\\\","g"),"/");

var regPath = "\\Software\\Classes\\";

var oShell = new ActiveXObject("WScript.Shell");
var regRoot;

var rez64 = check64bitsidebar();
if (rez64){
 var LibPath = gPath + "/GetGPUInfo64.dll";
 var LibPathName = "\\1.0\\0\\win64\\";
}
else{
 var LibPath = gPath + "/GetGPUInfo.dll";
 var LibPathName = "\\1.0\\0\\win32\\";
}//true

function check64bitsidebar(){
 var wmiService = GetObject("winmgmts:\\\\.\\root\\CIMV2");
 var WshShell = new ActiveXObject("WScript.Shell");
 try{
  var systmarch = wmiService.ExecQuery("SELECT OSArchitecture FROM Win32_OperatingSystem");
  var OS = (new Enumerator(systmarch)).item().OSArchitecture;
 }
 catch (e) {return false} 
 if (OS.slice(0,2) != "64") return false;
 try{
  var cursb = WshShell.RegRead("HKCU\\Software\\Microsoft\\Windows\\CurrentVersion\\Run\\SideBar");
  var versb = cursb.indexOf("Program Files (x86)");
  if (versb == -1) return true;
  else return false;
 }
 catch (e) {return true}  
}

function RegisterLibrary(){
 var classRoot = regRoot + regPath + Classname + "\\";
 var clsidRoot = regRoot + regPath + "CLSID\\" + dllCLSID + "\\";
 var typelibRoot = regRoot + regPath + "TypeLib\\";
 try{
  oShell.RegWrite(classRoot, ClassComment,"REG_SZ");
  oShell.RegWrite(classRoot + "CLSID\\",dllCLSID,"REG_SZ");
  oShell.RegWrite(classRoot + "CurVer\\",Classname,"REG_SZ");
		
  oShell.RegWrite(clsidRoot, ClassComment,"REG_SZ");
  oShell.RegWrite(clsidRoot + "InprocServer32\\",LibPath,"REG_SZ");
  oShell.RegWrite(clsidRoot + "InprocServer32\\ThreadingModel","Apartment","REG_SZ");
  oShell.RegWrite(clsidRoot + "ProgId\\",Classname,"REG_SZ");
  oShell.RegWrite(clsidRoot + "TypeLib\\",typeLib,"REG_SZ");
		
  oShell.RegWrite(typelibRoot + typeLib + "\\", "", "REG_SZ");
  oShell.RegWrite(typelibRoot + typeLib + "\\1.0\\", LibComment, "REG_SZ");
  oShell.RegWrite(typelibRoot + typeLib + "\\1.0\\0\\", "", "REG_SZ");
  oShell.RegWrite(typelibRoot + typeLib + LibPathName, LibPath, "REG_SZ");
  oShell.RegWrite(typelibRoot + typeLib + "\\1.0\\FLAGS\\", "0", "REG_SZ");
 }
 catch(e){}
}

function UnregisterLibrary(){
 var classRoot = regRoot + regPath + Classname + "\\";
 var clsidRoot = regRoot + regPath + "\\CLSID\\" + dllCLSID + "\\";
 var typelibRoot = regRoot + regPath + "TypeLib\\";
 try{
  oShell.RegDelete(clsidRoot + "ProgId\\");
  oShell.RegDelete(clsidRoot + "TypeLib\\");
  oShell.RegDelete(clsidRoot + "InprocServer32\\");
  oShell.RegDelete(clsidRoot);

  oShell.RegDelete(classRoot + "CLSID\\");
  oShell.RegDelete(classRoot + "CurVer\\");
  oShell.RegDelete(classRoot);
		
  oShell.RegDelete(typelibRoot + typeLib + LibPathName);
  oShell.RegDelete(typelibRoot + typeLib + "\\1.0\\0\\");
  oShell.RegDelete(typelibRoot + typeLib + "\\1.0\\FLAGS\\");
  oShell.RegDelete(typelibRoot + typeLib + "\\1.0\\");
  oShell.RegDelete(typelibRoot + typeLib + "\\");
 }
 catch(e){}
}

function ActivateLibrary(root){
 regRoot=root;
 try{
  RegisterLibrary();
  return new ActiveXObject(Classname);
 }
 catch(e){
  UnregisterLibrary();
  return null;
 }
}

function CreateObjectFromDLL(){
 var Object;
 Object = ActivateLibrary("HKCU");
 if (Object == null) Object = ActivateLibrary("HKLM");
 return Object;
}